package cn.dankal.test.rebalance;

import cn.dankal.test.factory.ThreadExecutorFactory;
import org.junit.jupiter.api.Test;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * 测试 Kafka 分区再均衡
 *
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-01-26
 */
public class KafkaRebalanceTest {
    /**
     * 测试 Kafka 分区再均衡
     */
    @Test
    public void testKafkaRebalance() throws InterruptedException {
        final int workerCount = 2;
        ThreadPoolExecutor threadPoolExecutor = ThreadExecutorFactory.getThreadPoolExecutor("dankal-test-kafka-rebalance");
        for (int i = 0; i < workerCount; i++) {
            ConsumerWorker consumerWorker = new ConsumerWorker(false);
            threadPoolExecutor.execute(consumerWorker::doWork);
        }
        TimeUnit.SECONDS.sleep(30);

        //启动一个临时消费者,触发分区再均衡
        ConsumerWorker tempConsumerWorker = new ConsumerWorker(true);
        threadPoolExecutor.execute(tempConsumerWorker::doWork);

        new CountDownLatch(1).await();
    }
}
