package cn.dankal.test.boot.common;

import java.time.format.DateTimeFormatter;

/**
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-01-21
 */
public interface Const {

    /**
     * random base string
     */
    String RANDOM_BASE_STRING = "zxcvbnmasdfghjklqwertyuiopQAZWSXEDCRFVTGBYHNIUJKLMOP1234567890-=[],.;'";


    /**
     * format pattern: yyyy-MM-dd HH:mm:ss.SSS
     */
    DateTimeFormatter FULL_DATE_TIME_FORMATTER = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSS");

    /**
     * kafka  相关常量
     */
    interface Kafka {
        /**
         * Kafka Consumer group id
         */
        interface ConsumerGroupId {
            /**
             * simple-string-consumer
             */
            String GROUP_ID_SIMPLE_STRING_CONSUMER = "simple-string-consumer";

            /**
             * hello-spring-kafka-group
             */
            String GROUP_ID_HELLO_SPRING_KAFKA_CONSUMER = "hello-spring-kafka-group";

            /**
             * test-string-message-handler-error
             */
            String GROUP_ID_TEST_STRING_MESSAGE_HANDLER_ERROR_CONSUMER = "test-string-message-handler-error";
        }

        /**
         * Kafka Topic
         */
        interface Topic {
            /**
             * simple-string-message
             * <p>
             * 简单 String message 主题
             * </p>
             */
            String TOPIC_SIMPLE_STRING_MESSAGE = "simple-string-message";

            /**
             * hello-spring-kafka
             * <p>
             * 测试 spring kafka 的主题
             * </p>
             */
            String TOPIC_HELLO_SPRING_KAFKA = "hello-spring-kafka";

            /**
             * handler-string-message-error-message
             * <p>
             * 存放 出现 string message 异常信息的主题
             * </p>
             */
            String TOPIC_HANDLER_STRING_MESSAGE_ERROR_MESSAGE = "handler-string-message-error-message";
        }
    }

}
