package cn.dankal.test.cloud.consumer.consumer;

import cn.dankal.test.cloud.consumer.common.Common;
import cn.dankal.test.cloud.consumer.common.Const;
import cn.dankal.test.cloud.consumer.entity.DankalSimpleMessage;
import cn.dankal.test.cloud.consumer.input.DankalMessageInput;
import lombok.extern.slf4j.Slf4j;
import org.springframework.cloud.stream.annotation.StreamListener;
import org.springframework.messaging.handler.annotation.Payload;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;

/**
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-02-04
 */
@Slf4j
@Component
public class ConditionDankalMessageConsumer {

    /**
     *  此消费者只消费  message header 带有: messageTag 并且其值为: dankal-condition
     * @param dankalSimpleMessage
     */
    @StreamListener(value = DankalMessageInput.INPUT_NAME,
            condition = "headers['messageTag']=='dankal-condition'")
    public void onMessage(@Payload DankalSimpleMessage dankalSimpleMessage) {
        log.info(
                "ConditionDankalMessageConsumer: {} {} 成功消费: {}",
                Const.FULL_DATE_TIME_FORMATTER.format(LocalDateTime.now()),
                Common.getSpringKafkaConsumerName(Thread.currentThread().getName()),
                dankalSimpleMessage
        );
    }
}
