# 蛋壳创意科技-技术测试-Kafka集群安装示例文档

> company: [蛋壳创意科技](https://www.dankal.cn/)
>
> official website: 
>
> - **[Kafka](https://kafka.apache.org/)**
> - **[Zookeeper](https://zookeeper.apache.org/)**
> - **[Logi-KafkaManager](https://github.com/didi/Logi-KafkaManager)**

## 前置环境准备

### Docker 安装

> **[docker-install-linux](https://docs.docker.com/engine/install/)**
>
> **[Docker 安装 | 菜鸟教程](https://www.runoob.com/docker/centos-docker-install.html)**

### Docker Compose 服务编排

> **[docker-compose-install](https://docs.docker.com/compose/install/)**
>
> **[Docker Compose 安装 | 菜鸟教程](https://www.runoob.com/docker/docker-compose.html)**

### 测试用例环境版本

> ##### CentOS 7.9.2009
>
> > LSB Version:	:core-4.1-amd64:core-4.1-noarch:cxx-4.1-amd64:cxx-4.1-noarch:desktop-4.1-amd64:desktop-4.1-noarch:languages-4.1-amd64:languages-4.1-noarch:printing-4.1-amd64:printing-4.1-noarch
> > Distributor ID:	CentOS
> > Description:	CentOS Linux release 7.9.2009 (Core)
> > Release:	7.9.2009
> > Codename:	Core
>
> ##### docker
>
> >  Docker version 20.10.1, build 831ebea
>
> ##### docker compose
>
> > docker-compose version 1.27.4, build 40524192

## 安装梗概

### kafka集群

> - kafka01
>   - port: 9092
>   - JMX Port: 9999
>
> - kafka02
>   - port: 9093
>   - JMX Port: 9988
> - kafka03
>   - port: 9094
>   - JMX Port: 9977

### Zookeeper 集群

> - zookeeper01
>   - id : 1
>   - port: 2181
> - zookeeper02
>   - id : 2
>   - port: 2182
> - zookeeper03
>   - id : 3
>   - port: 2183

### KafkaManager

> didi 2020 年新开源产品

### 安装方式

- Kafka 和 Zookeepr 集群采用  docker 形式安装

  - docker-compose: docker compose 异步编排

  - docker-compose.yml  version 和 docker 版本关系

    详情可参阅官网: [compose-file](https://docs.docker.com/compose/compose-file/)

    ![](https://img.mercymodest.com/public/20210125114852.png)

- Logi-KafkaManager 使用 jar 的形式运行

## docker network

便于  kafka 容器集群与  zookeeper 容器集群的通信，故在启动 zookeeper 和 kafka 集群之前需要先创建自定义的docker network

### ==执行命令==

> docker network create --driver bridge --subnet 172.128.0.0/25 --gateway 172.128.0.1  zookeeper_network

## Zookeeper 集群安装(docker)

Kafka 的集群管理依赖于 Zookeepr,虽然 Kafka 默认嵌入了 Zookeepr 但是建议使用自定义的 Zookeepr 集群

### docker-compose.yml

```yml
version: '3.7'
 
services:
 zookeeper01:
  image: zookeeper
  restart: always
  privileged: true
  container_name: zookeeper01
  hostname: zookeeper01
  ports:
   - 2181:2181
  volumes: # 挂载数据
   - ./zookeeper01/data:/data
   - ./zookeeper01/datalog:/datalog
  environment:
   ZOO_MY_ID: 1
   ZOO_SERVERS: server.1=0.0.0.0:2888:3888;2181 server.2=zookeeper02:2888:3888;2181 server.3=zookeeper03:2888:3888;2181
  networks:
   default:
    ipv4_address: 172.128.0.10
 
 zookeeper02:
  image: zookeeper
  restart: always
  privileged: true
  container_name: zookeeper02
  hostname: zookeeper02
  ports:
   - 2182:2181
  volumes: # 挂载数据
   - ./zookeeper02/data:/data
   - ./zookeeper02/datalog:/datalog
  environment:
   ZOO_MY_ID: 2
   ZOO_SERVERS: server.1=zookeeper01:2888:3888;2181 server.2=0.0.0.0:2888:3888;2181 server.3=zookeeper03:2888:3888;2181
  networks:
   default:
    ipv4_address: 172.128.0.11
 
 zookeeper03:
  image: zookeeper
  restart: always
  privileged: true
  container_name: zookeeper03
  hostname: zookeeper03
  ports:
   - 2183:2181
  volumes: # 挂载数据
   - ./zookeeper03/data:/data
   - ./zookeeper03/datalog:/datalog
  environment:
   ZOO_MY_ID: 3
   ZOO_SERVERS: server.1=zookeeper01:2888:3888;2181 server.2=zookeeper02:2888:3888;2181 server.3=0.0.0.0:2888:3888;2181
  networks:
   default:
    ipv4_address: 172.128.0.12
 
networks: # 自定义网络
 default:
  external:
   name: zookeeper_network
```

### 查看当前所在路径

![](https://img.mercymodest.com/public/20210125121417.png)

### 执行命令

==执行此命令 要求我们需要在 docker-compose.yml 所在目录下==

这也是为啥会有`查看当前所在路径`的步骤了~

> docker-compose   up  -d

![](https://img.mercymodest.com/public/20210125121625.png)tips: 因为我早已完成下载，所以我执行命令是直接启动容器,如果是第一次使用 当前 docker-compose.yml 会先下载我们所需要的容器，然后才会执行 `Createing`（自动执行,我们只需耐心等待即可）

### 集群启动结果确认

> docker  ps

![](https://img.mercymodest.com/public/20210125122448.png)

> docker  logs  zookeeper01 
>
> - (zookeeper01|zookeeper02|zookeeper03)

![](https://img.mercymodest.com/public/20210125122141.png)

如果没有出现异常日志,并且出现类似图示所圈日志信息，那么基本可以确认 基于 docker 容器的 zookeeper 已经成功启动~

## Kafka集群安装(docker)

相关路径问题可以参阅  Zookeeper集群安装(docker)#`查看当前所在路径`

### docker-compose.yml

```yml
version: '3.7'

services:
  kafka01:
    image: wurstmeister/kafka
    #restart: always
    hostname: kafka01
    container_name: kafka01
    ports:
      - "9092:9092"
      - "9999:9999"
    environment:
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://192.168.128.3:9092
      KAFKA_ADVERTISED_HOST_NAME: 192.168.128.3
      KAFKA_ADVERTISED_PORT: 9092
      KAFKA_ZOOKEEPER_CONNECT: zookeeper01:2181,zookeeper02:2181,zookeeper03:2181
      JMX_PORT: 9999
    volumes:
      - ./kafka01/logs:/kafka
    external_links:
      - zookeeper01
      - zookeeper02
      - zookeeper03
    networks:
      default:
        ipv4_address: 172.128.0.20

  kafka02:
    image: wurstmeister/kafka
    #restart: always
    hostname: kafka02
    container_name: kafka02
    ports:
      - "9093:9092"
      - "9988:9988"
    environment:
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://192.168.128.3:9093
      KAFKA_ADVERTISED_HOST_NAME: 192.168.128.3
      KAFKA_ADVERTISED_PORT: 9093
      KAFKA_ZOOKEEPER_CONNECT: zookeeper01:2181,zookeeper02:2181,zookeeper03:2181
      JMX_PORT: 9988
    volumes:
      - ./kafka02/logs:/kafka
    external_links:
      - zookeeper01
      - zookeeper02
      - zookeeper03
    networks:
      default:
        ipv4_address: 172.128.0.21

  kafka03:
    image: wurstmeister/kafka
    #restart: always
    hostname: kafka03
    container_name: kafka03
    ports:
      - "9094:9092"
      - "9977:9977"
    environment:
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://192.168.128.3:9094
      KAFKA_ADVERTISED_HOST_NAME: 192.168.128.3
      KAFKA_ADVERTISED_PORT: 9094
      KAFKA_ZOOKEEPER_CONNECT: zookeeper01:2181,zookeeper02:2181,zookeeper03:2181
      JMX_PORT: 9977
    volumes:
      - ./kafka03/logs:/kafka
    external_links:
      - zookeeper01
      - zookeeper02
      - zookeeper03
    networks:
      default:
        ipv4_address: 172.128.0.22
networks:
  default:
    external:
      name: zookeeper_network
```

### 执行命令

> docker-compose   up  -d

![](https://img.mercymodest.com/public/20210125122939.png)

### 集群启动结果确认

> docker ps 

![](https://img.mercymodest.com/public/20210125123035.png)

> docker  logs  kafka01
>
> - (kafka01|kafka02|kafka03)

![](https://img.mercymodest.com/public/20210125123209.png)

## Logi-KafkaManager 安装

> jar 包下载 : [kafka-manager-2.0.0.tar.gz](https://res.mercymodest.com/res/kafka-manager-2.0.0.tar.gz)
>
> 官方文档：[install_guide_cn.md](https://github.com/didi/Logi-KafkaManager/blob/master/docs/install_guide/install_guide_cn.md)

### 启动参考

#### 解压 tar 包

> tar  -zxvf  ./kafka-manager-2.0.0.tar.gz   

![](https://img.mercymodest.com/public/20210125123854.png)

#### 创建所需 MySQL 数据库

> 执行 create_mysql_table.sql 创建数据库

![](https://img.mercymodest.com/public/20210125124118.png)

#### 修改 application.yml

![](https://img.mercymodest.com/public/20210125124310.png)

##### etc.

```yml
server:
  port: 8182
  tomcat:
    accept-count: 1000
    max-connections: 10000
    max-threads: 800
    min-spare-threads: 100

spring:
  application:
    name: kafkamanager
  datasource:
    kafka-manager:
      jdbc-url: jdbc:mysql://rm-wz9z40fs394wti63aio.mysql.rds.aliyuncs.com:3306/dankal_kafka_manager?characterEncoding=UTF-8&serverTimezone=GMT%2B8
      username: dankal_master
      password: Dankal_system
      driver-class-name: com.mysql.jdbc.Driver
  main:
    allow-bean-definition-overriding: true

  profiles:
    active: dev
  servlet:
    multipart:
      max-file-size: 60MB
      max-request-size: 60MB

logging:
  config: classpath:logback-spring.xml

custom:
  idc: cn
  jmx:
    max-conn: 10

account:
  ldap:

kcm:
  enabled: false
  n9e:
    base-url: http://127.0.0.1:8080
    user-token: 12345678
    timeout: 300
    account: km
    script-file: kcm_script.sh

monitor:
  enabled: false
  n9e:
    nid: 2
    user-token: 123456
    mon:
      base-url: http://127.0.0.1:8032
    sink:
      base-url: http://127.0.0.1:8006
    rdb:
      base-url: http://127.0.0.1:80

notify:
  kafka:
    cluster-id: 95
    topic-name: didi-kafka-notify
  order:
    detail-url: http://127.0.0.1
```

#### 执行命令

> nohup java  -jar  kafka-manager.jar  --spring.config.location=./application.yml &

#### 执行结果确认

> tail  -f  nohup.out

![](https://img.mercymodest.com/public/20210125124651.png)

#### 浏览使用

##### 浏览器输入

> http://192.168.128.3:8182/
>
> tips: 192.168.128.3 是 运行 `Logi-KafkaManager `所在服务器IP 地址, 8182 是 在启动 `Logi-KafkaManager `使用的 `application.yml`所配置的 服务端口

##### 账号密码

> 用户名：
>
> ​     admin
>
> 密码: 
>
> ​     admin

![](https://img.mercymodest.com/public/20210125142328.png)

### 更多的使用

更多的使用可以参阅官方文档

**[user_guide](https://github.com/didi/Logi-KafkaManager/tree/master/docs/user_guide)**



